*************************************************************************************
*														*
*	Eight eights problem for the EASy68k simulator	2006/01/24				*
*														*
*	Eight eights problem. on startup the hardware display should be blank		*
*	except an eight in the rightmost digit, the aim is to have all the eight	*
*	digits show eight. This can be done using the eight switches below the		*
*	display, the shortest sequence to do this takes 45 switches.			*
*														*
*	This program now sets the hardware window and reads the addresses.		*
*														*
*	This version has deliberately had all comments removed and all labels		*
*	changed to obscure the program function.							*
*														*
*	More 68000 and other projects can be found on my website at ..			*
*														*
*	 http://www.themotionstore.com/leeedavison/index.html					*
*														*
*	.. or ..												*
*														*
*	 http://members.lycos.co.uk/leeedavison/index.html					*
*														*
*	mail : leeedavison@lycos.co.uk								*
*														*
*************************************************************************************

	ORG	$1000

LAB_0000
	LEA		LAB_0000(pc),sp	*
	MOVEQ		#32,d0		* 
	MOVEQ		#0,d1			* 
	TRAP		#15			* 

	MOVEQ		#1,d1			* 
	TRAP		#15			* 

	MOVEA.l	d1,a3			* 

	MOVEQ		#3,d1			* 
	TRAP		#15			* 

	MOVEA.l	d1,a4			* 

	MOVE.w	#$7F00,d3		* 
	LEA		LAB_000A(pc),a2	* 
	MOVE.b	(a4),d7		* 

	MOVEQ		#$0E,d0		* 
LAB_0001
	MOVE.w	#$0000,(a2,d0)	* 
	SUBQ		#$2,d0		* 
	BPL.s		LAB_0001		* 

LAB_0002
	MOVEQ		#$0E,d0		* 
LAB_0003
	MOVE.w	(a2,d0),d2		* 
	EOR.w		d3,d2			* 
	MOVE.w	d2,(a2,d0)		* 

	MOVEQ		#$0E,d0		* 
LAB_0004
	MOVE.w	(a2,d0),(a3,d0)	* 
	SUBQ		#$2,d0		* 
	BPL.s		LAB_0004		* 

LAB_0005
	MOVE.b	(a4),d0		* 
	CMP.b		d0,d7			* 
	BEQ.s		LAB_0005		* 

	MOVE.b	d0,d2			* 
	EOR.b		d7,d2			* 

	MOVE.b	d0,d7			* 

	MOVEQ		#7,d0			* 
LAB_0006
	LSR.b		#1,d2			* 
	BCS.s		LAB_0007		* 

	DBF		d0,LAB_0006		* 

LAB_0007
	ADD.l		d0,d0			* 
	CMP.b		#$0A,d0		* 
	BPL.s		LAB_0003		* 

	MOVEQ		#$0E,d6		* 
LAB_0008
	MOVE.w	(a2,d6),d2		* 
	BNE.s		LAB_0009		* 

	SUBQ.b	#$02,d6		* 
	BPL.s		LAB_0008		* 

LAB_0009
	SUBQ.b	#$02,d6		* 
	EOR.b		d0,d6			* 
	BEQ.s		LAB_0003		* 

	BRA.s		LAB_0002		* 

LAB_000A
	dc.w	$7468,$6973,$2069,$7320
	dc.w	$616C,$6C20,$6372,$6170

	END	LAB_0000


